package cn.ibizlab.core.analysis.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.core.analysis.domain.DAReport;
import cn.ibizlab.core.analysis.filter.DAReportSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[DAReport] 服务对象接口
 */
public interface IDAReportService extends IService<DAReport> {

    boolean create(DAReport et);
    void createBatch(List<DAReport> list);
    boolean update(DAReport et);
    void updateBatch(List<DAReport> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    DAReport get(String key);
    DAReport getDraft(DAReport et);
    boolean checkKey(DAReport et);
    boolean save(DAReport et);
    void saveBatch(List<DAReport> list);
    Page<DAReport> searchDefault(DAReportSearchContext context);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


